diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCrystal.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCrystal.java
index 768ff8e96..db8742538 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCrystal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorCrystal.java
@@ -2,7 +2,7 @@ package net.minecraft.client.render.block.color;
 
 import net.minecraft.client.render.colorizer.Colorizer;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.noise.ImprovedNoise;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
@@ -13,7 +13,7 @@ public class BlockColorCrystal extends BlockColorCustom{
     public BlockColorCrystal(Colorizer colorizer) {
         super(colorizer);
     }
-    protected static ImprovedNoise crystalPerlinNoise = new ImprovedNoise(new Random(0));
+    protected static ImprovedPerlinNoise crystalPerlinNoise = new ImprovedPerlinNoise(new Random(0));
     @Override
     public int getWorldColor(@NotNull WorldSource source, @NotNull TilePosc tilePos, int tintIndex) {
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java
index 4185895da..14f36fc6c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java
@@ -4,7 +4,7 @@ import java.util.Random;
 
 import net.minecraft.client.render.colorizer.Colorizer;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.noise.ImprovedNoise;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.Seasons;
@@ -12,7 +12,7 @@ import org.jetbrains.annotations.NotNull;
 
 public class BlockColorLeavesOak extends BlockColorCustom {
 
-    private static final @NotNull ImprovedNoise fallColorPerlin = new ImprovedNoise(new Random(0));
+    private static final @NotNull ImprovedPerlinNoise fallColorPerlin = new ImprovedPerlinNoise(new Random(0));
 
     public BlockColorLeavesOak(Colorizer colorizer) {
         super(colorizer);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
index 3222c3591..46026e08a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorTallGrass.java
@@ -5,13 +5,13 @@ import java.util.Random;
 import net.minecraft.client.render.colorizer.Colorizer;
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.noise.ImprovedNoise;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockColorTallGrass extends BlockColorCustom {
 	
-	protected static ImprovedNoise grassColorPerlin = new ImprovedNoise(new Random(0));
+	protected static ImprovedPerlinNoise grassColorPerlin = new ImprovedPerlinNoise(new Random(0));
 	
 	public BlockColorTallGrass(@NotNull Colorizer colorizer) {
 		super(colorizer);
diff --git a/game/core/src/main/java/net/minecraft/core/world/AuroraProvider.java b/game/core/src/main/java/net/minecraft/core/world/AuroraProvider.java
index 43cf3b070..347d007f5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/AuroraProvider.java
+++ b/game/core/src/main/java/net/minecraft/core/world/AuroraProvider.java
@@ -1,18 +1,18 @@
 package net.minecraft.core.world;
 
-import net.minecraft.core.world.noise.ImprovedNoise;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 
 import java.util.Random;
 
 public class AuroraProvider
 {
-    private final ImprovedNoise noise;
+    private final ImprovedPerlinNoise noise;
     private final World world;
 
     public AuroraProvider(World world, long seed)
     {
         this.world = world;
-        noise = new ImprovedNoise(new Random(seed));
+        noise = new ImprovedPerlinNoise(new Random(seed));
     }
 
     public double getAuroraPresence(double x, double z, long worldTime, float celestialAngle)
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java
index 37d3867d4..65960f0a0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java
@@ -2,28 +2,30 @@ package net.minecraft.core.world.biome.provider;
 
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
-import net.minecraft.core.world.noise.PerlinSimplexNoise;
+import net.minecraft.core.world.noise.FractalNoise2D;
+import net.minecraft.core.world.noise.FractalNoise3D;
+import net.minecraft.core.world.noise.Noise2D;
+import net.minecraft.core.world.noise.SimplexNoise;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Arrays;
-import java.util.Random;
 
 public class BiomeProviderB173
     extends BiomeProvider
 {
-    private static final float ZOOM = 2.0f;
-    private static final float TEMP_SCALE = 0.025F;
-    private static final float DOWNFALL_SCALE = 0.05F;
-    private static final float NOISE_SCALE = 0.25F;
+    private static final double ZOOM = 2.0;
+    private static final double TEMP_SCALE = 0.025;
+    private static final double DOWNFALL_SCALE = 0.05;
+    private static final double NOISE_SCALE = 0.25;
 
-    private final @NotNull PerlinSimplexNoise temperatureMap;
-    private final @NotNull PerlinSimplexNoise downfallMap;
-    private final @NotNull PerlinSimplexNoise noiseMap;
+    private final @NotNull FractalNoise2D<?> temperatureMap;
+    private final @NotNull FractalNoise2D<?> downfallMap;
+    private final @NotNull FractalNoise2D<?> noiseMap;
 
     public BiomeProviderB173(final long seed) {
-        this.temperatureMap = new PerlinSimplexNoise(new Random(seed * 9871L), 4);
-        this.downfallMap = new PerlinSimplexNoise(new Random(seed * 39811L), 4);
-        this.noiseMap = new PerlinSimplexNoise(new Random(seed * 543321L), 2);
+        this.temperatureMap = new FractalNoise2D<>(SimplexNoise.genOctaves(seed * 9871, 4));
+        this.downfallMap = new FractalNoise2D<>(SimplexNoise.genOctaves(seed * 39811, 4));
+        this.noiseMap = new FractalNoise2D<>(SimplexNoise.genOctaves(seed * 543321, 4));
     }
 
     @Override
@@ -35,19 +37,19 @@ public class BiomeProviderB173
         if (temperatures == null || temperatures.length < xSize * zSize) {
             temperatures = new double[xSize * zSize];
         }
-        this.temperatureMap.getRegion(temperatures, x, z, xSize, xSize, 0.025, 0.025, 0.25);
+        this.temperatureMap.setLacunarity(0.25).getRegion(temperatures, x, z, xSize, xSize, TEMP_SCALE, TEMP_SCALE);
 
         if (humidities == null || humidities.length < xSize * zSize) {
             humidities = new double[xSize * zSize];
         }
-        this.downfallMap.getRegion(humidities, x, z, xSize, xSize, 0.05, 0.05, 1.0 / 3.0);
+        this.downfallMap.setLacunarity(1.0 / 3.0).getRegion(humidities, x, z, xSize, xSize, DOWNFALL_SCALE, DOWNFALL_SCALE);
 
         if (varieties == null || varieties.length < xSize * zSize) {
             varieties = new double[xSize * zSize];
         }
         Arrays.fill(varieties, 0.0);
 
-        final double[] noises = this.noiseMap.getRegion(null, x, z, xSize, xSize, 0.25, 0.25, 0.5882352941176471D);
+        final double @NotNull [] noises = this.noiseMap.setLacunarity(10.0 / 17.0).getRegion(null, x, z, xSize, xSize, NOISE_SCALE, NOISE_SCALE);
 
         for (int xx = 0; xx < xSize; xx++) {
             for (int zz = 0; zz < zSize; zz++) {
@@ -93,9 +95,9 @@ public class BiomeProviderB173
         if (temperatures == null || temperatures.length < xSize * zSize) {
             temperatures = new double[xSize * zSize];
         }
+        this.temperatureMap.setLacunarity(0.25).getRegion(temperatures, x, z, xSize, xSize, TEMP_SCALE, TEMP_SCALE);
 
-        this.temperatureMap.getRegion(temperatures, x, z, xSize, xSize, 0.025, 0.025, 0.25);
-        final double[] noises = this.noiseMap.getRegion(null, x, z, xSize, zSize, 0.25, 0.25, 0.5882352941176471D);
+        final double @NotNull [] noises = this.noiseMap.setLacunarity(10.0 / 17.0).getRegion(null, x, z, xSize, zSize, NOISE_SCALE, NOISE_SCALE);
 
         int i = 0;
         for (int xx = 0; xx < xSize; xx++) {
@@ -125,8 +127,7 @@ public class BiomeProviderB173
         if (humidities == null || humidities.length < xSize * zSize) {
             humidities = new double[xSize * zSize];
         }
-
-        return this.downfallMap.getRegion(humidities, x, z, xSize, zSize, 0.05, 0.05, 0.5);
+        return this.downfallMap.setLacunarity(0.5).getRegion(humidities, x, z, xSize, zSize, DOWNFALL_SCALE, DOWNFALL_SCALE);
     }
 
     @Override
@@ -134,7 +135,6 @@ public class BiomeProviderB173
         if (varieties == null || varieties.length < xSize * zSize) {
             varieties = new double[xSize * zSize];
         }
-
         Arrays.fill(varieties, 0.0);
 
         return varieties;
@@ -145,7 +145,6 @@ public class BiomeProviderB173
         if (biomenesses == null || biomenesses.length < xSize * ySize * zSize) {
             biomenesses = new double[xSize * ySize * zSize];
         }
-
         Arrays.fill(biomenesses, 1.0);
 
         return biomenesses;
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
index 22e0dcc4a..9491a3120 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
@@ -2,11 +2,12 @@ package net.minecraft.core.world.biome.provider;
 
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
-import net.minecraft.core.world.noise.PerlinSimplexNoise;
+import net.minecraft.core.world.noise.FractalNoise2D;
+import net.minecraft.core.world.noise.FractalNoise3D;
+import net.minecraft.core.world.noise.SimplexNoise;
 import net.minecraft.core.world.type.WorldTypes;
 
 import java.util.Arrays;
-import java.util.Random;
 
 public final class BiomeProviderNether
     extends BiomeProvider
@@ -28,23 +29,22 @@ public final class BiomeProviderNether
             Biomes.NETHER_VOLCANIC_ISLANDS
     };
 
-    private final PerlinSimplexNoise temperatureNoise;
-    private final PerlinSimplexNoise fuzzinessNoise;
+    private final FractalNoise2D<?> temperatureNoise;
+    private final FractalNoise2D<?> fuzzinessNoise;
 
     private double temperatureXScale = 0.0125;
     private double temperatureZScale = 0.0125;
-    private double temperatureExponent = 0.25;
+    private double temperatureLacunarity = 0.25;
     private double temperatureFuzzPercentage = 0.01;
 
     private double fuzzinessXScale = 0.25;
     private double fuzzinessZScale = 0.25;
-    private double fuzzinessExponent = 1.0;
+    private double fuzzinessLacunarity = 1.0;
 
     public BiomeProviderNether(long seed)
     {
-        this.temperatureNoise = new PerlinSimplexNoise(new Random(seed * 5345L), 4);
-
-        this.fuzzinessNoise = new PerlinSimplexNoise(new Random(seed * 35864L), 2);
+        this.temperatureNoise = new FractalNoise3D<>(SimplexNoise.genOctaves(seed * 5345, 4));
+        this.fuzzinessNoise = new FractalNoise3D<>(SimplexNoise.genOctaves(seed * 35864, 2));
     }
 
     @Override
@@ -90,8 +90,8 @@ public final class BiomeProviderNether
     }
 
     public double getTemperature(double x, double z) {
-        double[] tnResult = temperatureNoise.getRegion(null, x, z, 1, 1, temperatureXScale, temperatureZScale, temperatureExponent);
-        double[] fnResult = fuzzinessNoise.getRegion(null, x, z, 1, 1, fuzzinessXScale, fuzzinessZScale, fuzzinessExponent);
+        double[] tnResult = temperatureNoise.setLacunarity(this.temperatureLacunarity).getRegion(null, x, z, 1, 1, temperatureXScale, temperatureZScale);
+        double[] fnResult = fuzzinessNoise.setLacunarity(this.fuzzinessLacunarity).getRegion(null, x, z, 1, 1, fuzzinessXScale, fuzzinessZScale);
 
         double fuzziness = fnResult[0] * 1.1 + 0.5;
 
@@ -118,8 +118,8 @@ public final class BiomeProviderNether
             temperatures = new double[xSize * zSize];
         }
 
-        double[] tnResult = temperatureNoise.getRegion(null, x, z, xSize, zSize, temperatureXScale, temperatureZScale, temperatureExponent);
-        double[] fnResult = fuzzinessNoise.getRegion(null, x, z, xSize, zSize, fuzzinessXScale, fuzzinessZScale, fuzzinessExponent);
+        double[] tnResult = temperatureNoise.setLacunarity(this.temperatureLacunarity).getRegion(null, x, z, xSize, zSize, temperatureXScale, temperatureZScale);
+        double[] fnResult = fuzzinessNoise.setLacunarity(this.fuzzinessLacunarity).getRegion(null, x, z, xSize, zSize, fuzzinessXScale, fuzzinessZScale);
 
         for (int dx = 0; dx < xSize; dx++)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
index 01403dfc3..3083b182f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
@@ -5,10 +5,11 @@ import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.data.BiomeRange;
 import net.minecraft.core.world.biome.data.BiomeRangeMap;
-import net.minecraft.core.world.noise.PerlinSimplexNoise;
+import net.minecraft.core.world.noise.FractalNoise2D;
+import net.minecraft.core.world.noise.FractalNoise3D;
+import net.minecraft.core.world.noise.SimplexNoise;
 import net.minecraft.core.world.type.WorldType;
 
-import java.util.Random;
 import java.util.Set;
 
 public final class BiomeProviderOverworld
@@ -16,29 +17,29 @@ public final class BiomeProviderOverworld
 {
     private static final BiomeRangeMap brm = new BiomeRangeMap();
 
-    private final PerlinSimplexNoise temperatureNoise;
-    private final PerlinSimplexNoise humidityNoise;
-    private final PerlinSimplexNoise varietyNoise;
-    private final PerlinSimplexNoise fuzzinessNoise;
+    private final FractalNoise2D<?> temperatureMap;
+    private final FractalNoise2D<?> humidityMap;
+    private final FractalNoise2D<?> varietyMap;
+    private final FractalNoise2D<?> noiseMap;
 
     private double temperatureXScale = 0.0125;
     private double temperatureZScale = 0.0125;
-    private double temperatureExponent = 0.25;
-    private double temperatureFuzzPercentage = 0.01;
+    private double temperatureLacunarity = 0.25;
+    private double temperatureNoise = 0.01;
 
     private double humidityXScale = 0.025;
     private double humidityZScale = 0.025;
-    private double humidityExponent = 0.3;
-    private double humidityFuzzPercentage = 0.01;
+    private double humidityLacunarity = 0.3;
+    private double humidityNoise = 0.01;
 
     private double varietyXScale = 0.25;
     private double varietyZScale = 0.25;
-    private double varietyExponent = 0.3;
-    private double varietyFuzzPercentage = 0.0;
+    private double varietyLacunarity = 0.3;
+    private double varietyNoise = 0.0;
 
-    private double fuzzinessXScale = 0.25;
-    private double fuzzinessZScale = 0.25;
-    private double fuzzinessExponent = 1.0;
+    private double noiseXScale = 0.25;
+    private double noiseZScale = 0.25;
+    private double noiseLacunarity = 1.0;
 
     private final WorldType worldType;
 
@@ -46,38 +47,37 @@ public final class BiomeProviderOverworld
     {
         this.worldType = worldType;
 
-        this.temperatureNoise = new PerlinSimplexNoise(new Random(seed * 9871L), 4);
-        this.humidityNoise = new PerlinSimplexNoise(new Random(seed * 39811L), 4);
-        this.varietyNoise = new PerlinSimplexNoise(new Random(seed), 4);
-
-        this.fuzzinessNoise = new PerlinSimplexNoise(new Random(seed * 0x84a59L), 2);
+        this.temperatureMap = new FractalNoise3D<>(SimplexNoise.genOctaves(seed * 9871, 4));
+        this.humidityMap = new FractalNoise3D<>(SimplexNoise.genOctaves(seed * 39811, 4));
+        this.varietyMap = new FractalNoise3D<>(SimplexNoise.genOctaves(seed, 4));
+        this.noiseMap = new FractalNoise3D<>(SimplexNoise.genOctaves(seed * 543321, 2));
     }
 
-    public BiomeProviderOverworld withTemperatureScales(double xScale, double zScale, double exponent, double fuzzPercentage)
+    public BiomeProviderOverworld withTemperatureScales(double xScale, double zScale, double lacunarity, double noise)
     {
         this.temperatureXScale = xScale;
         this.temperatureZScale = zScale;
-        this.temperatureExponent = exponent;
-        this.temperatureFuzzPercentage = fuzzPercentage;
+        this.temperatureLacunarity = lacunarity;
+        this.temperatureNoise = noise;
 
         return this;
     }
 
-    public BiomeProviderOverworld withHumidityScales(double xScale, double zScale, double exponent, double fuzzPercentage)
+    public BiomeProviderOverworld withHumidityScales(double xScale, double zScale, double lacunarity, double noise)
     {
         this.humidityXScale = xScale;
         this.humidityZScale = zScale;
-        this.humidityExponent = exponent;
-        this.humidityFuzzPercentage = fuzzPercentage;
+        this.humidityLacunarity = lacunarity;
+        this.humidityNoise = noise;
 
         return this;
     }
 
-    public BiomeProviderOverworld withFuzzinessScales(double xScale, double zScale, double exponent)
+    public BiomeProviderOverworld withNoiseScales(double xScale, double zScale, double lacunarity)
     {
-        this.fuzzinessXScale = xScale;
-        this.fuzzinessZScale = zScale;
-        this.fuzzinessExponent = exponent;
+        this.noiseXScale = xScale;
+        this.noiseZScale = zScale;
+        this.noiseLacunarity = lacunarity;
 
         return this;
     }
@@ -132,8 +132,8 @@ public final class BiomeProviderOverworld
             temperatures = new double[xSize * zSize];
         }
 
-        double[] tnResult = temperatureNoise.getRegion(null, x, z, xSize, zSize, temperatureXScale, temperatureZScale, temperatureExponent);
-        double[] fnResult = fuzzinessNoise.getRegion(null, x, z, xSize, zSize, fuzzinessXScale, fuzzinessZScale, fuzzinessExponent);
+        double[] tnResult = temperatureMap.setLacunarity(this.temperatureLacunarity).getRegion(null, x, z, xSize, zSize, temperatureXScale, temperatureZScale);
+        double[] fnResult = noiseMap.setLacunarity(this.noiseLacunarity).getRegion(null, x, z, xSize, zSize, noiseXScale, noiseZScale);
 
         for (int dx = 0; dx < xSize; dx++)
         {
@@ -141,7 +141,7 @@ public final class BiomeProviderOverworld
             {
                 double fuzziness = fnResult[dx * zSize + dz] * 1.1 + 0.5;
 
-                double fuzzPctg = temperatureFuzzPercentage;
+                double fuzzPctg = temperatureNoise;
                 double valPctg = 1.0 - fuzzPctg;
                 double temperature = (tnResult[dx * zSize + dz] * 0.15 + 0.7) * valPctg + fuzziness * fuzzPctg;
 
@@ -169,8 +169,8 @@ public final class BiomeProviderOverworld
             humidities = new double[xSize * zSize];
         }
 
-        double[] hnResult = humidityNoise.getRegion(null, x, z, xSize, zSize, humidityXScale, humidityZScale, humidityExponent);
-        double[] fnResult = fuzzinessNoise.getRegion(null, x, z, xSize, zSize, fuzzinessXScale, fuzzinessZScale, fuzzinessExponent);
+        double[] hnResult = humidityMap.setLacunarity(this.humidityLacunarity).getRegion(null, x, z, xSize, zSize, humidityXScale, humidityZScale);
+        double[] fnResult = noiseMap.setLacunarity(this.noiseLacunarity).getRegion(null, x, z, xSize, zSize, noiseXScale, noiseZScale);
 
         for (int dx = 0; dx < xSize; dx++)
         {
@@ -178,7 +178,7 @@ public final class BiomeProviderOverworld
             {
                 double fuzziness = fnResult[dx * zSize + dz] * 1.1 + 0.5;
 
-                double fuzzPctg = humidityFuzzPercentage;
+                double fuzzPctg = humidityNoise;
                 double valPctg = 1.0 - fuzzPctg;
                 double humidity = (hnResult[dx * zSize + dz] * 0.15 + 0.5) * valPctg + fuzziness * fuzzPctg;
 
@@ -205,8 +205,8 @@ public final class BiomeProviderOverworld
             varieties = new double[xSize * zSize];
         }
 
-        double[] vnResult = varietyNoise.getRegion(null, x, z, xSize, zSize, varietyXScale, varietyZScale, varietyExponent);
-        double[] fnResult = fuzzinessNoise.getRegion(null, x, z, xSize, zSize, fuzzinessXScale, fuzzinessZScale, fuzzinessExponent);
+        double[] vnResult = varietyMap.setLacunarity(this.varietyLacunarity).getRegion(null, x, z, xSize, zSize, varietyXScale, varietyZScale);
+        double[] fnResult = noiseMap.setLacunarity(this.noiseLacunarity).getRegion(null, x, z, xSize, zSize, noiseXScale, noiseZScale);
 
         for (int dx = 0; dx < xSize; dx++)
         {
@@ -214,7 +214,7 @@ public final class BiomeProviderOverworld
             {
                 double fuzziness = fnResult[dx * zSize + dz] * 1.1 + 0.5;
 
-                double fuzzPctg = varietyFuzzPercentage;
+                double fuzzPctg = varietyNoise;
                 double valPctg = 1.0 - fuzzPctg;
                 double variety = (vnResult[dx * zSize + dz] * 0.15 + 0.5) * valPctg + fuzziness * fuzzPctg;
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java
index aa23ce91f..23e4b195a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/IceFloeLargeFeature.java
@@ -7,8 +7,7 @@ import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
-import net.minecraft.core.world.noise.PerlinNoise;
-import net.minecraft.core.world.noise.WorleyNoise;
+import net.minecraft.core.world.noise.*;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.type.WorldType;
 import org.jetbrains.annotations.NotNull;
@@ -19,15 +18,15 @@ import java.util.Random;
 
 public class IceFloeLargeFeature
     extends LargeFeature {
-    private @Nullable PerlinNoise perlinNoise = null;
-    private @Nullable PerlinNoise scalePerlinNoise = null;
+    private @Nullable Noise2D noise = null;
+    private @Nullable Noise2D scaleNoise = null;
     private @Nullable World lastWorld = null;
 
     @Override
     protected void doGeneration(@NotNull final World world, @NotNull final Random random, final int chunkX, final int chunkZ, final int baseChunkX, final int baseChunkZ, @NotNull final ChunkGeneratorResult result) {
-        if (this.perlinNoise == null || this.scalePerlinNoise == null || this.lastWorld != world) {
-            this.perlinNoise = new PerlinNoise(world.getRandomSeed(), 4);
-            this.scalePerlinNoise = new PerlinNoise(world.getRandomSeed(), 2);
+        if (this.noise == null || this.scaleNoise == null || this.lastWorld != world) {
+            this.noise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 4));
+            this.scaleNoise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 2));
             this.lastWorld = world;
         }
 
@@ -44,12 +43,14 @@ public class IceFloeLargeFeature
                 final @NotNull Biome biome = world.getBlockBiome(tilePos);
                 if (biome == Biomes.OVERWORLD_GLACIER) {
                     final float worleyScaleScale = 50.0f;
-                    final float worleyScale = 0.875f + (float) (this.scalePerlinNoise.getNormalized((baseChunkX * Chunk.CHUNK_SIZE_X + x) / worleyScaleScale, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / worleyScaleScale)) * 0.25f;
+
+                    // TODO: NORMALIZE THIS
+                    final float worleyScale = 0.875f + (float) (this.scaleNoise.getValue((baseChunkX * Chunk.CHUNK_SIZE_X + x) / worleyScaleScale, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / worleyScaleScale)) * 0.25f;
                     vec.x = (baseChunkX + ((float) x / (float) Chunk.CHUNK_SIZE_X)) * worleyScale;
                     vec.y = (baseChunkZ + ((float) z / (float) Chunk.CHUNK_SIZE_Z)) * worleyScale;
                     WorleyNoise.getWorleyDistance2d(vec, worley);
                     final float lineScale = 10.0f;
-                    final float lineWidth = (float) (this.perlinNoise.getValue((baseChunkX * Chunk.CHUNK_SIZE_X + x) / lineScale, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / lineScale) / 2.0 + 0.5);
+                    final float lineWidth = (float) (this.noise.getValue((baseChunkX * Chunk.CHUNK_SIZE_X + x) / lineScale, (baseChunkZ * Chunk.CHUNK_SIZE_Z + z) / lineScale) / 2.0 + 0.5);
                     if (MathHelper.unsignedMod(worley.index, 15) != 0) {
                         if (worley.distance > 0.9f + lineWidth * 0.05f) {
                             continue;
